/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */
package org.apache.qpid.jms.test.testpeer.describedtypes.sections;

import org.apache.qpid.proton.amqp.Binary;
import org.apache.qpid.proton.amqp.DescribedType;
import org.apache.qpid.proton.amqp.Symbol;

public class DataDescribedType implements DescribedType
{
    private static final Symbol DESCIPTOR_SYMBOL = Symbol.valueOf("amqp:data:binary");
    private Binary _described;

    public DataDescribedType(Binary described)
    {
        if(described == null)
        {
            throw new IllegalArgumentException("provided Binary must not be null");
        }

        _described = described;
    }

    @Override
    public Object getDescriptor()
    {
        return DESCIPTOR_SYMBOL;
    }

    @Override
    public Object getDescribed()
    {
        return _described;
    }

}
